/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package server;

import controller.Controller;
import domain.Invoice;
import domain.Manufacturer;
import domain.Product;
import domain.User;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutput;
import java.io.ObjectOutputStream;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.List;
import java.util.Map;
import transfer.RequestObject;
import transfer.ResponseObject;
import util.Operation;

/**
 *
 * @author student1
 */
public class Server { //OVA KLASA SE NE KORISTI!!!!!
    ServerSocket serverSocket;
    Socket socket;

    public Server() {
    }
    
    public void start() throws IOException, Exception{
        serverSocket=new ServerSocket(9000);
        System.out.println("waiting...");
        socket=serverSocket.accept();
        System.out.println("client connected!!!");
        
        handleClient();
    }
    
    
    private void handleClient() throws IOException, ClassNotFoundException, Exception{
        
        while (true){
            RequestObject request=receiveRequest();
            ResponseObject response=null;
            switch(request.getOperation()){
                case Operation.OPERATION_LOGIN:
                    response=logIn(request);
                    break;
                case Operation.OPERATION_GET_ALL_MANUFACTURERS:
                    response=getAllManufacturers(request);
                    break;
                case Operation.OPERATION_SAVE_PRODUCT:
                    response=saveProduct(request);
                    break;
                case Operation.OPERATION_GET_ALL_PRODUCTS:
                    response=getAllProducts(request);
                    break;
                case Operation.OPERATION_SAVE_INVOICE:
                    response=saveInvoice(request);
                    break;
                    
            }
            sendResponse(response);
            
        }
    }
    
    private ResponseObject logIn(RequestObject request){
        Map<String, String> data=(Map<String, String>)request.getData();
        String username=(String)data.get("username");
        String password=(String)data.get("password");
        ResponseObject response=new ResponseObject();
        try{
            User user=Controller.getInstance().logIn(username, password);
            response.setData(user);
        }catch(Exception e){
            e.printStackTrace();
            response.setException(e);
        }
        return response;
    }
    
    private ResponseObject getAllManufacturers(RequestObject request) {
        ResponseObject response=new ResponseObject();
        try{
            List<Manufacturer> manufacturers=Controller.getInstance().getAllManufacturers();
            response.setData(manufacturers);
        }catch(Exception e){
            e.printStackTrace();
            response.setException(e);
        }
        return response;
    }

    private ResponseObject saveProduct(RequestObject request) {
        Product product=(Product)request.getData();
        
        ResponseObject response=new ResponseObject();
        try{
            Controller.getInstance().saveProduct(product);
            //response.setData(manufacturers);
        }catch(Exception e){
            e.printStackTrace();
            response.setException(e);
        }
        return response;
    }

    private ResponseObject getAllProducts(RequestObject request) {
        ResponseObject response=new ResponseObject();
        try{
            List<Product> products=Controller.getInstance().getAllProducts();
            response.setData(products);
        }catch(Exception e){
            e.printStackTrace();
            response.setException(e);
        }
        return response;
    }

    private ResponseObject saveInvoice(RequestObject request) {
        Invoice invoice=(Invoice)request.getData();
        
        ResponseObject response=new ResponseObject();
        try{
            invoice=Controller.getInstance().saveInvoice(invoice);
            response.setData(invoice);
        }catch(Exception e){
            e.printStackTrace();
            response.setException(e);
        }
        return response;
    }
    
    
    private RequestObject receiveRequest() throws IOException, ClassNotFoundException{
        ObjectInputStream in=new ObjectInputStream(socket.getInputStream());
        return (RequestObject)in.readObject();
    }
    
    private void sendResponse(ResponseObject response) throws IOException{
        ObjectOutputStream out=new ObjectOutputStream(socket.getOutputStream());
        out.writeObject(response);
        out.flush();
    }

    
}
